new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc_ = selif(Pc, Dates .== 19940215); 
o150294 = CouponZero_to_Obligation(Pc_',maturite);

Pc_ = selif(Pc, Dates .== 19941102);
o021194 = CouponZero_to_Obligation(Pc_',maturite);

Pc_ = selif(Pc, Dates .== 19950612);
o120695 = CouponZero_to_Obligation(Pc_',maturite);

Pc_ = selif(Pc, Dates .== 19960830);
o300896 = CouponZero_to_Obligation(Pc_',maturite);

tau = seqa(1/10,1/10,300);

TZ1 = zeros(300,2);
TZ2 = zeros(300,2);
TZ3 = zeros(300,2);
TZ4 = zeros(300,2);

c = NelsonSiegel_(o150294,1,0,0);
TZ1[.,1] = NelsonSiegel_TauxZero(c,tau);
c = Svensson_(o150294,1,0,0);
TZ1[.,2] = Svensson_TauxZero(c,tau);

c = NelsonSiegel_(o021194,1,0,0);
TZ2[.,1] = NelsonSiegel_TauxZero(c,tau);
c = Svensson_(o021194,1,0,0);
TZ2[.,2] = Svensson_TauxZero(c,tau);

c = NelsonSiegel_(o120695,1,0,0);
TZ3[.,1] = NelsonSiegel_TauxZero(c,tau);
c = Svensson_(o120695,1,0,0);
TZ3[.,2] = Svensson_TauxZero(c,tau);

c = NelsonSiegel_(o300896,1,0,0);
TZ4[.,1] = NelsonSiegel_TauxZero(c,tau);
c = Svensson_(o300896,1,0,0);
TZ4[.,2] = Svensson_TauxZero(c,tau);


graphset;
  begwind;
  window2(2,2,0,0.5);
  setwind(1);
    _pdate = ""; _ptitlht = 2.25; _pnum = 0; _paxes = 0;
    title("Comparaison des modeles de Nelson-Siegel et de Svensson");
    draw;

  setwind(2);

    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.25;
    xlabel("\202t\201"); ylabel("R]t[(\202t\201)");
    _plegstr = "Nelson-Siegel\0Svensson"; _plegctl = {2 6 3 4};

    xtics(0,10,1,12);
    ytics(0.054,0.062,0.002,0);
    title("15/02/94");
    xy(tau,TZ1);

  setwind(3);

    title("02/11/94");
    ytics(0.045,0.085,0.005,0);
    _plegctl = 0;
    xy(tau,TZ2);

  setwind(4);

    title("12/06/95");
    ytics(0.066,0.076,0.002,0);
    xy(tau,TZ3);

  setwind(5);

    title("30/08/96");
    ytics(0.035,0.065,0.005,0);
    xy(tau,TZ4);

    graphprt("-c=1 -cf=nelson3.eps -w=5");

  endwind;

