new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

tau = seqa(1/12,1/12,12*16);

theta1 = selif(coefficients, Dates_ .== 19940215);
theta2 = selif(coefficients, Dates_ .== 19941102);
theta3 = selif(coefficients, Dates_ .== 19950612);
theta4 = selif(coefficients, Dates_ .== 19960830);

theta = theta1|theta2|theta3|theta4;
call NelsonSiegel_TauxZero(theta',tau);

c1 = _NelsonSiegel_composante1;
c2 = _NelsonSiegel_composante2;
c3 = _NelsonSiegel_composante3;

graphset;
  begwind;
  window(2,2,0);
  setwind(1);
    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 0.30;
     title("Decomposition de Nelson et Siegel");
    _pmsgstr = "15/02/94\00002/11/94\00012/06/95\00030/08/96";
    _pmsgctl = 0.1~0.8~0.25~0~1~7~0 |
               0.1~0.6~0.25~0~1~7~0 |
               0.1~0.4~0.25~0~1~7~0 |
               0.1~0.2~0.25~0~1~7~0 ;
    _pline =   1~6~0.4~0.825~0.7~0.825~1~7~0 |
               1~1~0.4~0.625~0.7~0.625~1~7~0 |
               1~2~0.4~0.425~0.7~0.425~1~7~5 |
               1~3~0.4~0.225~0.7~0.225~1~7~0 ;
    draw;

  setwind(2);
    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.30;
    _plwidth = 0|0|5|0;
    xlabel("\202t\201");
    ylabel("c]1[(\202t\201)");
    xtics(0,15,1,12);
    ytics(0.06,0.10,0.01,0);
    xy(tau,c1);

  setwind(3);
    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.30;
    xlabel("\202t\201");
    ylabel("c]2[(\202t\201)");
    ytics(-0.05,0,0.01,0);
    xy(tau,c2);

  setwind(4);
    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.30;
    xlabel("\202t\201");
    ylabel("c]3[(\202t\201)");
    ytics(-0.012,0.004,0.004,0);
    xy(tau,c3);

    graphprt("-c=1 -cf=nscomp1.eps -w=5");

  endwind;




