new;
library pgraph,optmum;

rndseed 123;

declare external poids,_theta;

x0 = sortc(rndu(25,1)*10,1);
x = seqa(0.1,0.1,100);

proc f(x);
  local y;
  y = 5 - ln(_theta[1]^2 + _theta[2]^2*(x-_theta[3])^2);
  retp(y);
endp;

proc df(x);
  local y;
  y = -(2*_theta[2]^2*(x-_theta[3]))./(_theta[1]^2 + _theta[2]^2*
        (x-_theta[3])^2);
  retp(y);
endp;

proc ddf(x);
  local denom,num,y;
  denom = _theta[1]^2 + _theta[2]^2*(x-_theta[3])^2;
  num = - ( 2*_theta[2]^2*(x-_theta[3]) );
  y = (-2*_theta[2]^2*denom) - (2*_theta[2]^2*num.*(x-_theta[3]));
  y = y ./ (denom^2);
  retp(y);
endp;

_theta = 1|0.2|6;

y = f(x);
y0 = f(x0) + rndn(25,1)*0.15;

proc critere1(theta);
  local z,u,g;
  _theta = theta;
  z = f(x0);
  u = y0 - z;
  g = ddf(x0)^2;
  retp(sumc(g.*u^2));
endp;

proc critere2(theta);
  local z,u,g;
  _theta = theta;
  z = f(x0);
  u = y0 - z;
  retp(sumc(poids.*u^2));
endp;

{theta1,fmin,grd,retcode} = optmum(&critere1,1|0.5|5);

_theta = theta1;
y2 = f(x);

poids = 1;
theta2 = 1|0.5|5;
i = 1;
do until i > 5;
  {theta2,fmin,grd,retcode} = optmum(&critere2,theta2);
  _theta = theta2;
  poids = ddf(x0)^2;
  i = i + 1;
endo;

_theta = theta2;
y3 = f(x);


graphset;
  _pdate = ""; _pnum = 2;
  xlabel("x"); ylabel("y");
  _psym = x0~y0~14*ones(25,1)~4.5*ones(25,1)~2*ones(25,1)~ones(25,2);
  _plegstr = "courbe theorique\0001ere estimation\0002eme estimation";
  _plegctl = {2 6 5 1.5};
  _pltype = 6|1|3;
  graphprt("-c=1 -cf=recursif.eps -w=5");
  xy(x,y~y2~y3);


