new;
library spt,pgraph;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; mu3 = NS_frf[.,4]; tau1 = NS_frf[.,5];

R0 = mu1 + mu2;
Rinf = mu1;

data = Dates_~R0~Rinf;
data = Interpolation_Donnees( calendrier_31jpm(data,19940101,19961231) );

Nobs = rows(data);

output file = sptfrf2.out reset;

r = packr(data[.,2 3]);

call dstat(0,r);

r = packr( r - lag1(r) );

call dstat(0,r);

output off;


graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Taux zero court et long");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _pltype = 6|3;
  _plegstr = "R]t[(0)\000R]t[(\202\56\201)";
  _plegctl = {2 6 2.25 0.75};
  graphprt("-c=1 -cf=sptfrf2.eps -w=5");
  xy(seqa(1,1,Nobs),data[., 2 3]);



