new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

theta1 = selif(coefficients, Dates_ .== 19940215);
theta2 = selif(coefficients, Dates_ .== 19941102);
theta3 = selif(coefficients, Dates_ .== 19950612);
theta4 = selif(coefficients, Dates_ .== 19960830);

theta = theta1|theta2|theta3|theta4;
theta = theta';

tau = seqa(1/12,1/12,12*16);
m = seqa(1/12,1/12,12*16);

F1 = {};
i = 1;
do until i > 4;
  F1 = F1~NelsonSiegel_TauxATerme(theta[.,i],tau,0);  /* F_t(tau,0) */
  i = i + 1;
endo;

F2 = {};
i = 1;
do until i > 4;
  F2= F2~NelsonSiegel_TauxATerme(theta[.,i],tau,3);  /* F_t(tau,1) */
  i = i + 1;
endo;


F3 = {};
i = 1;
do until i > 4;
  F3 = F3~NelsonSiegel_TauxATerme(theta[.,i],1,m);  /* F_t(1,m) */
  i = i + 1;
endo;

graphset;
  begwind;
  window(2,2,0);
  setwind(1);
    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 0.30;
    fonts("simplex simgrma");
    title("Taux a terme F]t[\202\34t\201,m\202\118\201");
    _pmsgstr = "15/02/94\00002/11/94\00012/06/95\00030/08/96";
    _pmsgctl = 0.1~0.8~0.25~0~1~7~0 |
               0.1~0.6~0.25~0~1~7~0 |
               0.1~0.4~0.25~0~1~7~0 |
               0.1~0.2~0.25~0~1~7~0 ;
    _pline =   1~6~0.4~0.825~0.7~0.825~1~7~0 |
               1~1~0.4~0.625~0.7~0.625~1~7~0 |
               1~2~0.4~0.425~0.7~0.425~1~7~5 |
               1~3~0.4~0.225~0.7~0.225~1~7~0 ;
    draw;

  setwind(2);
    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.30;
    _plwidth = 0|0|5|0;
    xlabel("\202t\201");
    ylabel("F]t[\202\34t\201,0\202\118\201");
    xtics(0,10,1,12);
    ytics(0.03,0.09,0.01,0);
    xy(tau,F1);

  setwind(3);
    xlabel("\202t\201");
    ytics(0.05,0.09,0.01,0);
    ylabel("F]t[\202\34t\201,3\202\118\201");
    xy(tau,F2);

  setwind(4);
    xlabel("\201m");
    ytics(0.04,0.09,0.01,0);
    ylabel("F]t[\202\34\2011,m\202\118\201");
    xy(m,F3);

    graphprt("-c=1 -cf=sptfrf4.eps -w=5");

  endwind;





