new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

coefficients = NS_frf[.,2 3 4 5];
tau = seqa(1/12,1/12,12*16);
m = 1;

theta1 = selif(coefficients, Dates_ .== 19940215);
theta1 = theta1';

R1 = NelsonSiegel_TauxZero(theta1,tau);
F1 = NelsonSiegel_TauxATerme(theta1,tau,m);
Ant1 = (F1-R1);

theta2 = selif(coefficients, Dates_ .== 19950215);
theta2 = theta2';

R2 = NelsonSiegel_TauxZero(theta2,tau);
F2 = NelsonSiegel_TauxATerme(theta2,tau,m);
Ant2 = lagn((F2-R2),12);

theta3 = selif(coefficients, Dates_ .== 19960215);
theta3 = theta3';


R3 = NelsonSiegel_TauxZero(theta3,tau);
F3 = NelsonSiegel_TauxATerme(theta3,tau,m);
Ant3 = lagn((F3-R3),2*12);

graphset;
  fonts("simplex simgrma");
  _pnum = 2; _pdate = ""; _plwidth = 0|0|5|0; _pltype = 6|1|3;
  title("Anticipations d'inflation (m = 1 an)");
  xtics(1994,2004,1,0);
  let xlab = "" "Fev 1995" "" "Fev 1997"
             "" "Fev 1999" "" "Fev 2001"
             "" "Fev 2003" "" "Fev 2005";
  asclabel(xlab,0);
  ylabel("en %");
  graphprt("-c=1 -cf=inflat1.eps -w=5");
  xy(1994 + tau,(Ant1~Ant2~Ant3)*100);



