new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

m = 1/12;

Date1 = NS_frf[.,1];
tauDiese1 = NelsonSiegel_Inversion(NS_frf,m);

Date2 = NS_dem[.,1];
tauDiese2 = NelsonSiegel_Inversion(NS_dem,m);

data1 = date1~tauDiese1;
data1 = calendrier_31jpm(data1,19940101,19961231);

data2 = date2~tauDiese2;
data2 = calendrier_31jpm(data2,19940101,19961231);

Nobs = rows(data1);

graphset;
  begwind;
  makewind(9,0.5,0,5.855,1);
  makewind(9/2,6.855-0.5,0,0,1);
  makewind(9/2,6.855-0.5,0,0,1);
  makewind(9/2,6.855-0.5,9/2,0,1);
  makewind(9/2,6.855-0.5,9/2,0,1);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    fonts("simplex simgrma");
    title("Evolution de \202t\201[#](1 mois)");
    draw;

    graphset;
    _pdate = ""; _pnum = 2;
    _pnumht = 0.25; _ptitlht = 0.30; _paxht = 0.25;

  setwind(2);

    title("France");
    let xlab = " " " " " " " ";
    let ylab = "0 mois" "3 mois" "6 mois" "9 mois" "1 an" "15 mois"
               "18 mois" "21 mois";
    asclabel(xlab,ylab);
    xtics(1,Nobs,31*12,12);
    ytics(0,21/12,3/12,3);
    axmargin(2,0,1.5,1);
    bar(seqa(1,1,Nobs),data1[.,2]);

  setwind(3);

    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,ylab);
    draw;

  setwind(4);

    title("Allemagne");
    let xlab = " " " " " " " ";
    let ylab = "0 mois" "3 mois" "6 mois" "9 mois" "1 an" "15 mois"
               "18 mois" "21 mois";
    asclabel(xlab,ylab);
    bar(seqa(1,1,Nobs),data2[.,2]);

  setwind(5);

    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,ylab);
    draw;

    graphprt("-c=1 -cf=inflat5.eps -w=5");

  endwind;


