new;
library spt;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
{S,P,N1} = NelsonSiegel_SPN(NS_frf,1/100,1);
{S,P,N2} = NelsonSiegel_SPN(NS_frf,1,5);
{S,P,N3} = NelsonSiegel_SPN(NS_frf,5,10);
{S,P,N4} = NelsonSiegel_SPN(NS_frf,0.01,30);

N = N1~N2~N3~N4;

N = Interpolation_Donnees(calendrier_31jpm(Dates~N,19940101,19961231));

N = N[.,2 3 4 5];

output file = spn3.out reset;

y = packr(N);
Mcor = corrx(y);

print "Matrice de covariance des spreads (niveau)";
call printfm(Mcor,1,"*.*lf"~8~3});

y = packr(y - lag1(y));
Mcor = corrx(y);

print "Matrice de covariance des spreads (difference)";
call printfm(Mcor,1,"*.*lf"~8~3});

std = zeros(4,2);
std2 = zeros(4,2);

i = 1;
do until i > 4;
  yi = N[.,i];
  yi = packr(yi);
  si = stdc(yi);
  std[i,1] = si;
  std2[i,1] = meanc(abs(yi - meanc(yi)));

  yi = packr(yi - lag1(yi));
  yi = packr(yi);
  si = stdc(yi);
  std[i,2] = si;
  std2[i,2] = meanc(abs(yi - meanc(yi)));

  i = i + 1;
endo;

print;
print "Niveau / Difference";
call printfm(std,1,"*.*lf"~10~5});

print;
print "Niveau / Difference";
call printfm(std2,1,"*.*lf"~10~5});

output off;




