new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates_ = NS_dem[.,1];

coefficients = NS_dem[.,2 3 4 5];

tau = seqa(1/12,6/12,2*6);
tau = tau|seqa(6,3,9);
call  NelsonSiegel_TauxZero(coefficients',tau);

c1 = _NelsonSiegel_composante1';
c2 = _NelsonSiegel_composante2';
c3 = _NelsonSiegel_composante3';

data2 = Dates_~c2;
data2 = Interpolation_Donnees( calendrier_31jpm(data2,0,0) );

data3 = Dates_~c3;
data3 = Interpolation_Donnees( calendrier_31jpm(data3,0,0) );

dates = data2[.,1];
data2 = trimr(data2',1,0)';
data3 = trimr(data3',1,0)';
Nobs = rows(dates);

d = seqa(1,1,Nobs);

graphset;
  _pdate = ""; _pnum = {2,0,2}; _paxht = 0.20; _pnumht = 0.17;
    fonts("simplex simgrma");
  title("Evolution de la composante c]2[(\202t\201)");
  xlabel("maturite (annees)");
  ylabel("   1996   1995   1994  ");
  xtics(0,30,5,5);
  ytics(1,rows(d),372,0);
  ztics(-120,20,20,2);
  graphprt("-c=1 -cf=sptdem2.eps -w=5");
  surface(tau',d,data2*1000);

  title("Evolution de la composante c]3[(\202t\201)");
  ztics(-30,10,10,2);
  graphprt("-c=1 -cf=sptdem3.eps -w=5");
  surface(tau',d,data3*1000);




