new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
theta = NS_frf[.,2 3 4 5];
theta = theta';

tau = (1|6)/12;

R = NS_frf[.,2] + NS_frf[.,3];

F = NelsonSiegel_TauxATerme(theta,tau,0);
F = F';

data = dates~R~F;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);
data = data[.,2:4];

data = shiftr(data',0|31|6*31,miss(0,0))';

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4|3; _plwidth = 0|5|0;
  let xlab = "1994" "1995" "1996" "1997";
  title("Anticipation du taux r]t[");
  _plegstr = "r]t[\000f]t[(1/12)\000f]t[(1/2)";
  _plegctl = {2 5 2 1};
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  graphprt("-c=1 -cf=terme4.eps -w=5");
  xy(seqa(1,1,Nobs),data);

data = data[.,2 3] - data[.,1];

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4|3; _plwidth = 0|5|0;
  let xlab = "1994" "1995" "1996" "1997";
  title("Erreur de prevision ex-post");
  _plegstr = "f]t[(1/12)-r]t+30[\000f]t[(1/2)-r]t+180[";
  _plegctl = {2 5 2 1};
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  graphprt("-c=1 -cf=terme5.eps -w=5");
  xy(seqa(1,1,Nobs),data);



