new;
library spt;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
theta = NS_frf[.,2:5]';

tau = (7/360)|seqa(1,1,12)/12;
Ntau = rows(tau);

R = NS_frf[.,2] + NS_frf[.,3];
F = NelsonSiegel_TauxATerme(theta,tau,0)';

data = dates~R~F;
data = calendrier_31jpm(data,19940101,19961231);

rot = 0|7|(seqa(31,31,12));
data = trimr(data',1,0);

data = shiftr(data,rot,miss(0,0))';
data = data[.,2:Ntau+1] - data[.,1];

output file = terme7.out reset;

i = 1;
do until i > Ntau;
  err = packr(data[.,i]);
  m = meanc(err);
  s = stdc(err);
  np = sumc(err.>0)/rows(err);
  print m~s~np;
  i = i + 1;
endo;

output off;


