new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
theta = NS_frf[.,2 3 4 5];
theta = theta';

tau = (7|120)/365;

R1 = NS_frf[.,2] + NS_frf[.,3];

R2 = NelsonSiegel_TauxZero(theta,1);
R2 = R2';

F1 = NelsonSiegel_TauxATerme(theta,tau,0);
F1 = F1';

F2 = NelsonSiegel_TauxATerme(theta,tau[2],1);
F2 = F2';

R = R1~R2;
F = F1~F2;

data = dates~R~F;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);

dates = data[.,1];
R1 = data[.,2];
R2 = data[.,3];
F1 = data[.,4 5];
F2 = data[.,6];

e1 = (F1 - R1)~(F2 - R2);
e2 = lagn(R1,-7)~lagn(R1,-4*31)~lagn(R2,-4*31);
e2 = e2 - (R1~R1~R2);

e1 = e1 .* ( e2 ./= miss(0,0));

e1 = (e1 .> 0) - (e1 .< 0);
e2 = (e2 .> 0) - (e2 .< 0);

graphset;
  begwind;
  window(2,3,0);

  setwind(1);

    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2;
    _pnumht = 0.30; _ptitlht = 0.4; _paxht = 0.30;
    let xlab = "1995" "1996" "" "";
    title("sgn(]1[e]t[)\L(\202t\201=7 jours, m = 0)");
    asclabel(xlab,0);
    ytics(-1,1,2,0);
    xtics(1,Nobs,31*12,12);
    bar(seqa(1,1,Nobs),e1[.,1]);

  setwind(2);

    title("sgn(]1[e]t[)\L(\202t\201=120 jours, m = 0)");
    bar(seqa(1,1,Nobs),e1[.,2]);

  setwind(3);

    title("sgn(]1[e]t[)\L(\202t\201=120 jours, m = 1 an)");
    bar(seqa(1,1,Nobs),e1[.,3]);

  setwind(4);

    title("sgn(]2[e]t[)\L(\202t\201=7 jours, m = 0)");
    bar(seqa(1,1,Nobs),e2[.,1]);

  setwind(5);

    title("sgn(]2[e]t[)\L(\202t\201=120 jours, m = 0)");
    bar(seqa(1,1,Nobs),e2[.,2]);

  setwind(6);

    title("sgn(]2[e]t[)\L(\202t\201=120 jours, m = 1 an)");
    bar(seqa(1,1,Nobs),e2[.,3]);

    graphprt("-c=1 -cf=terme9.eps -w=5");
  endwind;

