new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Date_dem = NS_dem[.,1];

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
Date_frf = NS_frf[.,1];

d = 19940210;
pos1 = indexcat(Date_frf,d);
pos2 = indexcat(Date_dem,d);

if scalerr(pos1) or scalerr(pos2);
  end;
endif;

coefficient_frf = NS_frf[.,2 3 4 5];
coefficient_dem = NS_dem[.,2 3 4 5];

tau = seqa(1/12,1/12,120);
m = seqa(1/12,1/12,120);

x1 = zeros(120,120);
x2 = zeros(120,120);

i = 1;
do until i > 120;

   x1[.,i] = NelsonSiegel_TauxATerme(coefficient_frf[pos1,.]',tau,m[i]);
   x2[.,i] = NelsonSiegel_TauxATerme(coefficient_dem[pos1,.]',tau,m[i]);

   i = i + 1;

endo;

graphset;
  fonts("simplex simgrma"); _pnum = 2; _pframe = 0;
  _paxht = 0.18; _pnumht = 0.18;
  _pdate = "";
  title("F]t[(\202t\201,m)-F]t[[*](\202t\201,m)\L10/02/1994");
  m2 = m[seqa(1,5,22)];
  _pline3d = 0~zeros(1,2)~0~(10~0).*ones(1,1)~ones(1,1).*(7~6~10~0);
  _pline3d = _pline3d  |
             0~zeros(1,2)~10~(0~0).*ones(1,1)~ones(1,1).*(7~6~10~0);
  xlabel("m");
  ylabel("\202t\201");
  zlabel("en \%");
  xtics(0,10,1,0);
  ytics(0,10,1,0);
  graphprt("-c=1 -cf=change5.eps");
  surface(m',tau,100*(x2-x1));
