new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Date_dem = NS_dem[.,1];

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
Date_frf = NS_frf[.,1];

coefficient_frf = NS_frf[.,2 3 4 5];
coefficient_dem = NS_dem[.,2 3 4 5];

phi1 = {};
phi2 = {};

m = seqa(1/12,1/12,72);
tau = seqa(1/12,1/12,10*12);

d = 19940210|19950509|19960830;

i = 1;
do until i > 3;

  pos1 = indexcat(Date_frf,d[i]);
  pos2 = indexcat(Date_dem,d[i]);

  if scalerr(pos1) or scalerr(pos2);
    end;
  endif;

  F1_frf = NelsonSiegel_TauxATerme(coefficient_frf[pos1,.]',0,m);
  F1_dem = NelsonSiegel_TauxATerme(coefficient_dem[pos1,.]',0,m);
  phi1 = phi1 ~ (F1_frf-F1_dem);

  F2_frf = NelsonSiegel_TauxATerme(coefficient_frf[pos1,.]',tau,1/12);
  F2_dem = NelsonSiegel_TauxATerme(coefficient_dem[pos1,.]',tau,1/12);
  phi2 = phi2 ~ (F2_frf-F2_dem);

  i = i + 1;
endo;

phi1 = 100*phi1;
phi2 = 100*phi2;

graphset;
    begwind;
    window(2,3,0);

    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2;
    _pnumht = 0.30; _paxht = 0.35; _ptitlht = 0.35;

    setwind(1);

      title("\202f\201(10/02/1994,0,m)");
      _pline = 1~3~0~0~100~0~1~7~0;
      xlabel("m");
      xtics(0,6,1,10);
      ytics(-0.1,0.5,0.1,0);
      xy(m,phi1[.,1]);

    setwind(2);

      title("\202f\201(10/02/1994,\202t\201,1/12)");
      xlabel("\202t\201");
      xtics(0,10,2,2);
      ytics(-0.5,0.5,0.25,0);
      xy(tau,phi2[.,1]);

   setwind(3);

      title("\202f\201(09/05/1995,0,m)");
      _pline = 1~3~0~0~100~0~1~7~0;
      xlabel("m");
      xtics(0,6,1,10);
      ytics(0.6,1.8,0.4,4);
      xy(m,phi1[.,2]);

    setwind(4);

      title("\202f\201(09/05/1995,\202t\201,1/12)");
      xlabel("\202t\201");
      xtics(0,10,2,2);
      ytics(-0.2,1.8,0.5,0);
      xy(tau,phi2[.,2]);

   setwind(5);

      title("\202f\201(30/08/1996,0,m)");
      _pline = 1~3~0~0~100~0~1~7~0;
      xlabel("m");
      xtics(0,6,1,10);
      ytics(0.3,0.8,0.1,0);
      xy(m,phi1[.,3]);

    setwind(6);

      title("\202f\201(30/08/1996,\202t\201,1/12)");
      xlabel("\202t\201");
      xtics(0,10,2,2);
      ytics(-0.4,0.8,0.4,0);
      xy(tau,phi2[.,3]);

      graphprt("-c=1 -cf=change6.eps");

    endwind;
