new;
library spt,pgraph,tsm;
TSMset;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Date_dem = NS_dem[.,1];

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
Date_frf = NS_frf[.,1];

Date_ = intrsect(Date_dem,Date_frf,1);
Nobs = rows(Date_);

psi = zeros(Nobs,3);

tau = 0; m = (1|6|12)/12;

i = 1;
do until i > Nobs;

  pos = indexcat(Date_frf,Date_[i]);
  coefficient_frf = NS_frf[pos,2 3 4 5]';

  pos = indexcat(Date_dem,Date_[i]);
  coefficient_dem = NS_dem[pos,2 3 4 5]';

  j = 1;
  do until j > 3;

    F_frf = NelsonSiegel_TauxATerme(coefficient_frf,tau,m[j]);
    F_dem = NelsonSiegel_TauxATerme(coefficient_dem,tau,m[j]);

    psi[i,j] = F_frf - F_dem;

    j = j + 1;
  endo;

  i = i + 1;
endo;

data = Interpolation_donnees(calendrier_31jpm(Date_~psi,19940101,19961231));
data = shiftr(data',(0|1|6|12)*31,miss(0,0))';
psi = data[.,2 3 4];
Nobs = rows(data);

graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    fonts("simplex simgrma");
    title("Evolution de la fonction \202f\201(t,0,m)");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|4; _plwidth = 0|0;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma");

  setwind(2);

    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    ytics(-0.01,0.04,0.01,10);
    _plegctl = {2 7 4.5 0.8};
    _plegstr = "m = 1/12";
    xy(seqa(1,1,Nobs),psi[.,1]);

  setwind(3);

    _plegstr = "m = 1/2\000m = 1";
    xy(seqa(1,1,Nobs),psi[.,2 3]);

    graphprt("-c=1 -cf=change7.eps");

  endwind;
