new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

coefficients = NS_frf[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

var = "0"|"1/12"|"2/12"|"3/12"|"1/2"|"9/12"|"1"|
      "2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"15"|"20"|"25"|"30"|"infini";

__output = 0;

{va,ve,scores} = acp(var,TauxZero,1,5);
qlt_obs = vread(_acp,"QLT_obs");

data = Dates_~scores[.,1:3]~qlt_obs[.,1:3];

data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);

graphset;
  _pdate = ""; _pnum = 2;
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _pline = 1~4~0~0~Nobs~0~0~7~1;
  title("1[er] axe factoriel\Lscore des observations");
  graphprt("-c=1 -cf=acp2.eps");
  xy(seqa(1,1,Nobs),data[.,2]);

  title("2[eme] axe factoriel\Lscore des observations");  
  graphprt("-c=1 -cf=acp4.eps");
  xy(seqa(1,1,Nobs),data[.,3]);

  title("3[eme] axe factoriel\Lscore des observations");  
  graphprt("-c=1 -cf=acp6.eps");
  xy(seqa(1,1,Nobs),data[.,4]);

  let xlab = "1995" "1996" "1997" "";
  asclabel(xlab,0);
  ytics(0,100,10,10);
  title("1[er] axe factoriel\Lqualite de representation des observations");
  graphprt("-c=1 -cf=acp3.eps");
  bar(seqa(1,1,Nobs),data[.,5]);

  title("2[eme] axe factoriel\Lqualite de representation des observations");
  graphprt("-c=1 -cf=acp5.eps");
  bar(seqa(1,1,Nobs),data[.,6]);

  title("3[eme] axe factoriel\Lqualite de representation des observations");
  graphprt("-c=1 -cf=acp7.eps");
  bar(seqa(1,1,Nobs),data[.,7]);
