new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

declare external cp;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

coefficients = NS_frf[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

var = "0"|"1/12"|"2/12"|"3/12"|"1/2"|"9/12"|"1"|
      "2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"15"|"20"|"25"|"30"|"infini";

Nobs = rows(TauxZero);
N = cols(TauxZero);
y = TauxZero;

proc H(t);
  local Ht;

  if cp == 0;
    Ht = ones(N,1);
    retp(Ht);
  endif;

  Ht = (ones(cp,1)|zeros(N-cp,1))~
       (zeros(cp,1)|ones(N-cp,1));

  retp(Ht);
endp;

proc m(t);
  retp(zeros(N,1));
endp;

proc MM(t);
  retp(eye(N));
endp;

proc F(t);
  if cp == 0;
    retp(1);
  endif;
  retp(eye(2));
endp;

proc d(t);
  if cp == 0;
    retp(0);
  endif;
  retp(0|0);
endp;

proc DD(t);
  if cp == 0;
    retp(1);
  endif;
  retp(eye(2));
endp;


Q0 = eye(1);
p0 = 0;

_print = 1;

Np = cols(TauxZero)-1;
CM = zeros(Np,1);

lambda = 100;
cp = 0;
{a,u,as,us} = gfls(y,&H,&m,&MM,&F,&d,&DD,Q0,p0,lambda);
CM[1] = _cost[1];

Q0 = eye(2);
p0 = 0|0;

i = 2;
do until i > Np;
  cp = i-1;
  {a,u,as,us} = gfls(y,&H,&m,&MM,&F,&d,&DD,Q0,p0,10000);
  CM[i] = _cost[1];
  i = i + 1;
endo;

SCT = sumc(sumc(y^2));
R2 = 100*(1-CM/SCT);
R2 = R2|R2[1];

ind = maxindc(R2);
cp = ind-1;
{a,u,as,us} = gfls(y,&H,&m,&MM,&F,&d,&DD,Q0,p0,10000);

data = Dates_~a;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
c1 = data[.,2];
c2 = data[.,3];
Nobs = rows(data);

graphset;
  _pdate = ""; _pnum = 2;
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _pline = 1~4~0~0~Nobs~0~0~7~1;
  title("Spread tendanciel a]2,t[-a]1,t[");
  ylabel("en %");
  graphprt("-c=1 -cf=inobs1.eps");
  xy(seqa(1,1,Nobs),100*(c2-c1));
