new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
TauxZero = R0~Rinf;

y = 100*TauxZero;

Z = 1|-1;
H = zeros(2,2);
R = 1;

proc ml(theta);
  local a,b,n,sigma;
  local d,T,c,Q,a0,P0,LogL;   

  a = theta[1]; b = theta[2]; n = theta[3]; sigma = theta[4];

  d = n*ones(2,1);
  T = 1-a;
  c = a*b;
  Q = sigma^2;

  call SSM_build(Z,d,H,T,c,R,Q,0);

  {a0,P0} = SSM_ic;
  a0 = 0; P0 = 0; 

  call KFiltering(y,a0,P0);
  LogL = KF_ml;
  retp(LogL);
endp;


_print = 1;
_tsm_optmum = 1;
_tsm_Mcov = 3;
_tsm_parnm = "a"|"b"|"n"|"sigma";

load sv = inobs3;

output file = inobs3.out reset;

{theta,stderr,Mcov,Logl} = TD_ml(&ml,sv);

output off;

save inobs3 = theta;
