new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

cls;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates1 = NS_frf[.,1];
Dates2 = NS_dem[.,1];
Dates = intrsect(Dates1,Dates2,1);
Nobs = rows(Dates);

data1 = zeros(Nobs,5);
data2 = zeros(Nobs,5);

i = 1;
do until i > Nobs;
  indx = indexcat(Dates1,Dates[i]);
  data1[i,.] = NS_frf[indx,.];
  indx = indexcat(Dates2,Dates[i]);
  data2[i,.] = NS_dem[indx,.];
  i = i + 1;
endo;

tau = 3|10;

coefficients = data1[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero_frf = R0~Rtau;
coefficients = data2[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero_dem = R0~Rtau;

Nvar = 6;

Nr = 250;
qlt = zeros(Nr,4);

__output = 0;
_fourier = 0;
_surrogate_random = 0;

i = 1;
do until i > Nr;
   y = surrogate(TauxZero_frf)~surrogate(TauxZero_dem);
   {va,ve,scores} = acp(0,y,1,4);
   qlt[i,.] = 100*va'/Nvar;  
   locate 5,5; print /flush ftos(i,"Iteration no. %lf",2,0);
   i = i + 1;
endo;


let xmin = 40   0  0.4 0.2;
let xmax = 100 60  1.2 0.6;

x = {};
d = {};
i = 1;
do until i > 4;
  _Kernel = xmin[i]|xmax[i]|128|6|0|100;
  {x_,d_,F_,retcode} = Kernel(qlt[.,i]);
  x = x~x_;
  d = d~d_;
  i = i + 1;
endo;


graphset;
  begwind;
  window(2,2,0);
  setwind(1);

    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 0.30;
    fonts("simplex simgrma complex microb");
    _pmsgstr = "\203       Fonction de densite\000"\
               " de la qualite de representation\000"\
               "des trois premiers axes factoriels\000"\
               " sous l'hypothese d'independance\000"\
               "    des courbes de taux zero\000"\
               "     francaise et allemande\201";
    _pmsgctl = 0.1~0.9~0.25~0~1~7~0 |
               0.1~0.75~0.25~0~1~7~0 |
               0.1~0.6~0.25~0~1~7~0 |
               0.1~0.45~0.25~0~1~7~0 |
               0.1~0.3~0.25~0~1~7~0 |
               0.1~0.15~0.25~0~1~7~0 ;
    draw;

  graphset;
    _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;

  setwind(2);

    title("1[er] axe factoriel");
    _pline = 1~1~76.68~0~76.68~100~0~7~1;
    xtics(40,100,10,10);
    xy(x[.,1],d[.,1]);

  setwind(3);

    title("2[eme] axe factoriel");
    _pline = 1~1~14.05~0~14.05~100~0~7~1;
    xtics(0,60,10,10);
    xy(x[.,2],d[.,2]);

  setwind(4);

    title("3[eme] axe factoriel");
    _pline = 1~1~8.17~0~8.17~100~0~7~1;
    xtics(0.4,1.2,0.2,2);
    xy(x[.,3],d[.,3]);

  graphprt("-c=1 -cf=mltltrl4.eps");

  endwind;
