new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

cls;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates1 = NS_frf[.,1];
Dates2 = NS_dem[.,1];
Dates = intrsect(Dates1,Dates2,1);
Nobs = rows(Dates);

data1 = zeros(Nobs,5);
data2 = zeros(Nobs,5);

i = 1;
do until i > Nobs;
  indx = indexcat(Dates1,Dates[i]);
  data1[i,.] = NS_frf[indx,.];
  indx = indexcat(Dates2,Dates[i]);
  data2[i,.] = NS_dem[indx,.];
  i = i + 1;
endo;

NS_frf = data1[.,1 2 3 4 5];
NS_dem = data2[.,1 2 3 4 5];

{S_frf,P,N} = NelsonSiegel_SPN(NS_frf,0,1);
{S_dem,P,N} = NelsonSiegel_SPN(NS_dem,0,1);

tau = 1|5|10;

coefficients = data1[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

S_frf = (Rtau-R0)~S_frf;

coefficients = data2[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

S_dem = (Rtau-R0)~S_dem;


B = zeros(Nobs,4);
i = 1;
do until i > 4;

  y = 100*S_frf[.,i];
  x = 100*S_dem[.,i];

  {Bfls,u,r2M,r2D} = FLS(y,ones(Nobs,1)~x,1000); 
  B[.,i] = Bfls[.,2];
  i = i + 1;
endo;


data = dates~B;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);
B = data[.,2:5];


graphset;
  begwind;
  window(2,2,0);
    _pdate = ""; _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);

  setwind(1);
    title("S]t[(1)");   
    ytics(0.1,0.9,0.2,0);
    xy(seqa(1,1,Nobs),B[.,1]);

  setwind(2);   
    title("S]t[(5)");  
    xy(seqa(1,1,Nobs),B[.,2]);

  setwind(3);   
    title("S]t[(10)");  
    xy(seqa(1,1,Nobs),B[.,3]);

  setwind(4);   
    title("S]t[");  
    ytics(-0.3,0.5,0.2,0);
    xy(seqa(1,1,Nobs),B[.,4]);

    graphprt("-c=1 -cf=mltltrl7.eps -w=5");
  endwind;
