new;
library spt,pgraph,tsm,optmum;
TSMset;

declare external theta;

load estim = estim1;
indx = 1|2|3|4|5|6|7|8|10;

proc Mu(t,x);
  retp( theta[1] + theta[2]*(x^theta[3]) );
endp;

proc Sigma(t,x);
  retp( theta[4]*(x^theta[5]) );
endp;


r0 = 0.02|0.05|0.08;
tau = 1/12;
N = 100;
Ns = 500;
x1 = zeros(128,11); d1 = zeros(128,11);
x2 = zeros(128,11); d2 = zeros(128,11);
x3 = zeros(128,11); d3 = zeros(128,11);

_kernel[1:2] = 0|0.10;

i = 1;
do until i > 9;
  theta = estim[.,indx[i]];

  {t,r} = simulation_EDS(r0[1],&Mu,&Sigma,0,tau,N,Ns);
  rT = r[N,.]';
  {x1[.,i],d1[.,i],F,retcode} = Kernel(rT);

  {t,r} = simulation_EDS(r0[2],&Mu,&Sigma,0,tau,N,Ns);
  rT = r[N,.]';
  {x2[.,i],d2[.,i],F,retcode} = Kernel(rT);

  {t,r} = simulation_EDS(r0[3],&Mu,&Sigma,0,tau,N,Ns);
  rT = r[N,.]';
  {x3[.,i],d3[.,i],F,retcode} = Kernel(rT);

  i = i + 1;
endo;

let string titre[9,1] = "Merton @[1973@]" 
                        "Vasicek @[1977@]"
                        "Dothan @[1978@]"
                        "Brennan et Schwartz @[1980@]"
                        "CIR @[1980@]"
                        "CIR @[1985b@]"
                        "Longstaff @[1989@]"
                        "CKLS @[1992@]"
                        "De Winne @[1994@]";

let ymax[9,1] = 60 60 150 150 200 100 100 200 200;
let ystep[9,1] = 20 20  50  50  50  50  50  50  50;

graphset;
  begwind;
  window2(3,3,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2; _pnum = 0; _paxes = 0;
    fonts("simplex simgrma");
    title("Fonction de densite conditionnelle de r(t]0[+1/12)");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pnumht = 0.30; _paxht = 0.30; _ptitlht = 0.35;
    xtics(0,0.10,0.02,0);  

    i = 1;
    do until i > 9;

      setwind(1+i);
        _plegctl = 0;

        if i == 5;
          _plegstr = "r(t]0[) = 2%\000r(t]0[) = 5%\000r(t]0[) = 8%";
          _plegctl = {2 7 3 2.5};
        endif;

        title(titre[i]);
        ytics(0,ymax[i],ystep[i],0);
        xy(x1[.,i]~x2[.,i]~x3[.,i],d1[.,i]~d2[.,i]~d3[.,i]);

      i = i + 1;
    endo;

    graphprt("-c=1 -cf=etude3.eps");

    endwind;
