new;
library tsm,optmum,spt,pgraph;
TSMset;

cls;

rndseed 456;

X0 = 10;
mu = 0.2;
sigma = 0.5;
k = 5|1|0.5|0.1;
sv = mu|sigma;

Nr = 250;  /* Nombre de replications */

__output = 0;
_print = 0;
_tsm_Mcov = 0;


Nobs = 500;
Est500_mu = zeros(Nr,4);
Est500_sigma = zeros(Nr,4);

j = 1;
do until j > 4;

  i = 1;
  do until i > Nr;
    {t,x} = simulation_MBG(x0,mu,sigma,0,Nobs*k[j],Nobs,1);
    {theta,stderr,Mcov,Logl} = ml_MBG(x,k[j],sv,0,0);
    str = "500 observations --- " $+ ftos(i,"Replication %lf",2,0) $+
                          ftos(j," --- j = %lf",3,2);
    locate 5,5; print str;
    Est500_mu[i,j] = theta[1];
    Est500_sigma[i,j] = theta[2];   
    i = i + 1;
  endo;

  j = j + 1;
endo;

Nobs = 100;
Est100_mu = zeros(Nr,4);
Est100_sigma = zeros(Nr,4);

j = 1;
do until j > 4;

  i = 1;
  do until i > Nr;
    {t,x} = simulation_MBG(x0,mu,sigma,0,Nobs*k[j],Nobs,1);
    {theta,stderr,Mcov,Logl} = ml_MBG(x,k[j],sv,0,0);
    str = "100 observations --- " $+ ftos(i,"Replication %lf",2,0) $+
                          ftos(j," --- j = %lf",3,2);
    locate 5,5; print str;
    Est100_mu[i,j] = theta[1];
    Est100_sigma[i,j] = theta[2];   
    i = i + 1;
  endo;

  j = j + 1;
endo;



save simul1 = Est500_mu;
save simul2 = Est500_sigma;
save simul3 = Est100_mu;
save simul4 = Est100_sigma;


load Est500_mu = simul1;
load Est500_sigma = simul2;
load Est100_mu = simul3;
load Est100_sigma = simul4;


X1 = {};
D1 = {};

_Kernel[1:2] = 0|0.4;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(Est500_mu[.,i]);
  X1 = X1~xi;
  D1 = D1~di;

  i = i + 1;
endo;


X2 = {};
D2 = {};

_Kernel[1:2] = 0.4|0.6;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(abs(Est500_sigma[.,i]));
  X2 = X2~xi;
  D2 = D2~di;

  i = i + 1;
endo;


X3 = {};
D3 = {};

_Kernel[1:2] = 0|0.4;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(Est100_mu[.,i]);
  X3 = X3~xi;
  D3 = D3~di;

  i = i + 1;
endo;


X4 = {};
D4 = {};

_Kernel[1:2] = 0.4|0.6;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(abs(Est100_sigma[.,i]));
  X4 = X4~xi;
  D4 = D4~di;

  i = i + 1;
endo;



graphset;
  begwind;
  window2(2,2,0,1);

  setwind(1);

    _pdate = ""; _ptitlht = 0.9; _pnum = 0; _paxes = 0;
    title("Densite empirique des estimateurs de la methode du maximum\L"\
          "de vraisemblance pour le mouvement brownien geometrique\L"\
          "250 replications");
    draw;

  graphset;
    _pnum = 2; _pdate = ""; _pnumht = 0.25; _ptitlht = 0.25; 
    _pltype = 6|1|3|4;
    fonts("simplex simgrma");
  
  setwind(2);
    xtics(0,0.4,0.1,10);
    ytics(0,30,5,5);
    _pline = 1~6~0.2~0~0.2~100~1~7~0;
    _plegstr = "k = 5\000k = 1\0k = 0.5\0k = 0.1";
    title("\201parametre \202m\201\L(500 observations)");
    _plegctl = {2 7 7.5 -1};
    xy(X1,D1);

  setwind(3);
    xtics(0.4,0.6,0.05,5);
    ytics(0,25,5,5);
    title("\201parametre \202s\201\L(500 observations)");
    _pline = 1~6~0.5~0~0.5~100~1~7~0;
    _plegctl = {2 7 -1.5 -1};
    xy(X2,D2);

  setwind(4);
    xtics(0,0.4,0.1,10);
    ytics(0,30,5,5);
    title("\201parametre \202m\201\L(100 observations)");
    _pline = 1~6~0.2~0~0.2~100~1~7~0;
    _plegctl = {2 7 7.5 5.855};
    xy(X3,D3);

  setwind(5);
    xtics(0.4,0.6,0.05,5);
    ytics(0,25,5,5);
    title("\201parametre \202s\201\L(100 observations)");
    _pline = 1~6~0.5~0~0.5~100~1~7~0;
    _plegctl = {2 7 -1.5 5.855};
    xy(X4,D4);
    
    graphprt("-c=1 -cf=mbg1.eps");
  endwind;  