new;
library tsm,optmum,spt,pgraph;
TSMset;

cls;

rndseed 456;

x0 = 0;
a = 0.8;
b = 0.1;
sigma = 0.06;
k = 5|1|0.5|0.1;
sv = a|b|sigma;

Nr = 250;  /* Nombre de replications */

__output = 0;
_print = 0;
_tsm_Mcov = 0;

Nobs = 1000;
Est1000_a = zeros(Nr,4);
Est1000_b = zeros(Nr,4);
Est1000_sigma = zeros(Nr,4);

j = 1;
do until j > 4;

  i = 1;
  do until i > Nr;
    {t,x} = simulation_OU(x0,a,b,sigma,0,Nobs*k[j],Nobs,1);
    {theta,stderr,Mcov,Logl} = gmm_OU(x,k[j],sv,0,0);
    str = "1000 observations --- " $+ ftos(i,"Replication %lf",2,0) $+
                          ftos(j," --- j = %lf",3,2);
    locate 5,5; print str;
    Est1000_a[i,j] = theta[1];
    Est1000_b[i,j] = theta[2];
    Est1000_sigma[i,j] = theta[3];   
    i = i + 1;
  endo;

  j = j + 1;
endo;


save simul14 = Est1000_a;
save simul15 = Est1000_b;
save simul16 = Est1000_sigma;


load Est1000_a = simul14;
load Est1000_b = simul15;
load Est1000_sigma = simul16;


X1 = {};
D1 = {};

_kernel[1:2] = 0.50|1.50;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(Est1000_a[.,i]);
  X1 = X1~xi;
  D1 = D1~di;

  i = i + 1;
endo;


X2 = {};
D2 = {};

_kernel[1:2] = 0.08|0.12;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(Est1000_b[.,i]);
  X2 = X2~xi;
  D2 = D2~di;

  i = i + 1;
endo;


X3 = {};
D3 = {};

_Kernel[1:2] = 0.05|0.07;

i = 1;
do until i > 4;

  {xi,di,Fi,retcode} = Kernel(abs(Est1000_sigma[.,i]));
  X3 = X3~xi;
  D3 = D3~di;

  i = i + 1;
endo;


graphset;
  begwind;
  window(2,2,0);

  setwind(1);

    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 0.30;
    fonts("simplex simgrma complex microb");
    _pmsgstr = "\203Densite empirique des estimateurs de\000"\
                   "la methode des moments generalises\000"\
                   "pour le processus d'Ornstein-Uhlenbeck\000"\
                   "250 replications -- 1000 observations";
           
    _pmsgctl = 
               0.05~0.75~0.23~0~1~7~0 |
               0.05~0.6~0.23~0~1~7~0 |
               0.05~0.45~0.23~0~1~7~0 |
               0.05~0.2~0.23~0~1~7~0 ;            
    draw;

  graphset;
    _pnum = 2; _pdate = ""; _pnumht = 0.25; _ptitlht = 0.25; 
    _pltype = 6|1|3|4;
    fonts("simplex simgrma");
  
  setwind(2);

    xtics(0.5,1.2,0.1,10);
    ytics(0,8,1,0);
    title("\201parametre a");
    _pline = 1~6~0.8~0~0.8~1000~1~7~0;
    xy(X1,D1);

  setwind(3);
    xtics(0.08,0.12,0.01,0);
    ytics(0,300,50,0);
    title("\201parametre b");
    _pline = 1~6~0.10~0~0.10~1000~1~7~0;
    _plegstr = "k = 5\000k = 1\0k = 0.5\0k = 0.1";
    _plegctl = {2 7 7.5 2};
    xy(X2,D2);

  setwind(4);

    xtics(0.05,0.07,0.01,0);
    ytics(0,350,50,0);
    title("\201parametre \202s\201");
    _pline = 1~6~0.06~0~0.06~1000~1~7~0;
    _plegctl = {2 7 -1.5 2};
    xy(X3,D3);
   
    graphprt("-c=1 -cf=ou5.eps");

  endwind;