new;
library spt,pgraph;
SPTset;

Msym ".";

cls;

fichier = spt_data_path $+ "NS_frf";
load NSfrf = ^fichier;

Dates = NSfrf[.,1];
NScoeff = NSfrf[.,2 3 4 5];   /* Coefficients de Nelson et Siegel */
Nobs = rows(NScoeff);

tau = 1|2|3;
let volatilite = 0.10 0.11;

Taux = miss(zeros(3,Nobs),0);

i = 1;
do until i > Nobs;

  TauxZero = NelsonSiegel_TauxZero(NScoeff[i,.]',tau);
  R = BDT(TauxZero,Volatilite);

  if rows(R) /= 6;
    i = i + 1;
    continue;
  endif;

  taux[.,i] = selectionArbre(R,2);

  locate 5,5; print /flush ftos(i,"Iteration no %lf",3,0);

  i = i + 1;
endo;

data = Interpolation_Donnees( calendrier_31jpm(Dates~Taux',19940101,19961231) );
Nobs = rows(data);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3|4;
  fonts("simplex simgrma");
  title("Modele de Black, Derman et Toy");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _plegstr = "r[(2)]]2[(1)\000r[(2)]]1[(1)\000r[(2)]]0[(1)";
  _plegctl = {2 6 6 4.5};
  graphprt("-c=1 -cf=bdt1.eps");
  xy(seqa(1,1,Nobs),data[.,2 3 4]);


