new;
library spt,pgraph;
SPTset;

cls;

F0 = 0.10;
t0 = 1;
t = 2;
sigma1 = 0.02;
sigma2 = 0.05;
c = 0.125;

rndseed 123;
Ns = 100;

proc procSigma(theta,T);
  local Nobs;
  Nobs = maxc(rows(theta)|rows(T));
  retp( sigma1*ones(Nobs,1) ~ sigma2.*exp(-c/2.*(T-theta)) );
endp;

TauxZero = HeathJarrowMorton(F0,&procSigma,t0,t,100,Ns);

dt = t-t0;
mt = F0 + 0.5*(sigma1*dt)^2 
      -2*(sigma2/c)^2*( (1-exp(-c*dt)) - 2*(1-exp(-c/2*dt)) );
sigmat = sqrt((sigma1^2)*dt + (sigma2^2)*(1-exp(-c*dt))/c);

rstar = 0.15;
d = (mt - rstar)/sigmat;
caplet = 1000 * ((mt-rstar)*cdfn(d) + sigmat*pdfn(-d));

G = (TauxZero - rstar);
G = G .* (G .> 0);

s = seqa(1,1,Ns);
C = 1000*cumsumc(G)./s;


graphset;
  _pdate = ""; _pnum = 2; 
  fonts("simplex simgrma");
  title("Convergence de la methode de Monte Carlo"\
        "\Lvaleur du caplet dans le modele HJM");
  xtics(0,100,25,5);
  xlabel("Nombre de simulations");
  graphprt("-c=1 -cf=hjm3.eps");
  xy(s,C~caplet*ones(Ns,1));
