new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];

tau = seqa(1/12,1/12,12);
CZ = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau);
Nobs = cols(CZ);

cap = zeros(Nobs,1);
pi_ = 0.5;
delta = 0.99;

i = 1;
do until i > Nobs;

	P = ArbreHoLee(CZ[.,i],pi_,delta);
    P1 = selectionArbreHoLee(P,1);
    r1 = HoLeeTaux(P1,360,30);
    G = 1000*HoLeeCap(r1,0.07)*30/360;
    {V,ArbreV} = HoLeeValorisation(G,P1,pi_);
    cap[i] = sumc(V);

    i = i + 1;
endo;


data = dates~cap;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
cap = data[.,2];
Nobs = rows(data);


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4|3;
  fonts("simplex simgrma");
  title("Prime du cap 1 an de taux d'exercice 7%"\
        "\Lcontrat de 1000 francs"\
        "\L\202p\201 = 50%  \202d\201 = 0.99");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12); 
  graphprt("-c=1 -cf=holee4.eps");
  xy(seqa(1,1,Nobs),cap);

