new;
library spt,pgraph,tsm,optmum;
TSMset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3];
r0 = mu1+mu2;

/* caracteristiques de l'obligation */

coupons = 100~100~100~500;
tau = 1~2~3~4;

pCZ0 = exp(-r0.*tau);
prix0 = prixObligation(coupons,pCZ0);
d0 = durationObligation(coupons,pCZ0,tau);
TA0 = TauxActuariel(prix0,coupons,tau);

pCZ1 = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau')';
prix1 = prixObligation(coupons,pCZ1);
d1 = durationObligation(coupons,pCZ1,tau);
TA1 = TauxActuariel(prix1,coupons,tau);

kappa = 2.116; theta = 0.1060/2.116; sigma = 0.01089; lambda = 0.0;
{pCZ2,TZ2} = CIR(r0,kappa,theta,sigma,0,tau);
prix2 = prixObligation(coupons,pCZ2);
d2 = durationObligation(coupons,pCZ2,tau);
TA2 = TauxActuariel(prix2,coupons,tau);

data = Dates~prix0~d0~TA0~prix1~d1~TA1~prix2~d2~TA2;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);
prix0 = data[.,2];
d0 = data[.,3];
TA0 = data[.,4];
prix1 = data[.,5];
d1 = data[.,6];
TA1 = data[.,7];
prix2 = data[.,8];
d2 = data[.,9];
TA2 = data[.,10];

graphset;
  begwind;
  window2(1,2,0,6.855/2);

    _pdate = ""; _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.30;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");

    setwind(1);
      _pltype = 5|4|6;
      title("Prix de l'obligation");
      _plegstr = "modele I - r]0[\000modele II - P[c](\202t\201)\000modele III - CIR";
      _plegctl = {2 6.5 5.75 1};
      ytics(620,720,20,0);
      xy(seqa(1,1,Nobs),prix0~prix1~prix2);
    setwind(2);
      _pltype = 4|6;
      _plegctl = 0;
      title("Taux actuariel");
      ytics(0.04,0.08,0.01,0);
      xy(seqa(1,1,Nobs),TA1~TA2);
    setwind(3);
      title("Difference maximale de duration");
      ytics(0,20,10,0);
      _plctrl = -3;
      _pstype = 7;
      _psymsiz = 4;
      ylabel("jours");
      d = (d0~d1~d2).*365;
      d = maxc(d') - minc(d');
      xy(seqa(1,1,Nobs),d);

      graphprt("-c=1 -cf=obligat.eps");
    endwind;
  
  



