new;
library spt,pgraph;
SPTset;

cls;

declare external a;

S0 = 100;
K = 90;
sigmaS = 0.20;
tau = 90/365;

proc muVasicek(t,r);
  retp( a*(0.10-r) );
endp;

proc sigmaVasicek(t,r);
  retp( 0.05 );
endp;

proc lambdaVasicek(t,r);
  retp( 0.05 );
endp;


r0 = seqa(0,0.01,21);
C = zeros(21,1);
Cs = zeros(21,3);

Ns = 1000|10;

i = 1;
do until i > 21;

  a = 0.5;  
  {C[i],Cs[i,1]} = callBlackScholes(S0,K,sigmaS,0,tau,r0[i],
                                  &muVasicek,&sigmaVasicek,&lambdaVasicek,100,Ns);
  a = 1;  
  {C[i],Cs[i,2]} = callBlackScholes(S0,K,sigmaS,0,tau,r0[i],
                                  &muVasicek,&sigmaVasicek,&lambdaVasicek,100,Ns);
  a = 5;  
  {C[i],Cs[i,3]} = callBlackScholes(S0,K,sigmaS,0,tau,r0[i],
                                  &muVasicek,&sigmaVasicek,&lambdaVasicek,100,Ns);

  locate 5,5; print /flush ftos(i,"iteration no. %lf",2,0);

  i = i + 1;
endo;


graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Prime d'une option europeenne d'achat\L"\
         "S]0[ = 100  K = 90  \202s\201]S[ = 20%  \202t\201 = 90 jours\L"\ 
         "b = 10%  \202s\201]r[ = 5%  \202l\201 = 0.05");
  _plegstr = "Black-Scholes"\
             "\000Taux d'interet stochastique (a = 0.5)"\
             "\000Taux d'interet stochastique (a = 1)"\
             "\000Taux d'interet stochastique (a = 5)";
  _plegctl = {2 5 1 4};
  _pltype = 6|1|3|4;
  xtics(0,0.20,0.05,5);0
  ytics(11,15,1,0);
  xlabel("r(t]0[)");
  graphprt("-c=1 -cf=option2.eps");
  xy(r0,C~Cs);
