new;
library spt,pgraph;

/* Option d'achat du 02/01/1992 */

C = 0.15; F0 = 90.25; K = 90.3; tau = 0.20; 
sigma = 0.01093;

a = 0.01|seqa(0.1,0.1,19);
deltaT = tau/5;
t = seqa(deltaT,deltaT,5);

TauxZero = 0.0975*ones(5,1);
CouponZero = exp(-t.*TauxZero);
C1 = zeros(rows(a),1);

i = 1;
do until i > rows(a);
  C1[i] = optionFuture(CouponZero,a[i],sigma,deltaT,K);  
  i = i + 1;
endo;

TauxZero = 0.0975 | 0.0974 | 0.0973 | 0.0972 | 0.0971;
CouponZero = exp(-t.*TauxZero);
C2 = zeros(rows(a),1);

i = 1;
do until i > rows(a);
  C2[i] = optionFuture(CouponZero,a[i],sigma,deltaT,K);  
  i = i + 1;
endo;

TauxZero = 0.0975 | 0.0976 | 0.0977 | 0.0978 | 0.0979;
CouponZero = exp(-t.*TauxZero);
C3 = zeros(rows(a),1);

i = 1;
do until i > rows(a);
  C3[i] = optionFuture(CouponZero,a[i],sigma,deltaT,K);  
  i = i + 1;
endo;


graphset;
  _pdate = ""; _pnum = 2; _paxht = 0.20;
  title("Influence de la structure par terme sur la prime"\
        "\Ld'une option d'achat sur Matif-Pibor future 3 mois");
  _plctrl = -1; _psymsiz = 6;
  _plegstr = "spt plate\000spt descendante\000spt ascendante";
  _plegctl = {2 6 5.5 4.25};
  xlabel("a"); 
  ytics(0.10,0.20,0.02,0);
  graphprt("-c=1 -cf=hw3.eps");
  xy(a,C1~C2~C3);


proc optionFuture(CouponZero,a,sigma,deltaT,K);
  local arbreHW,G,payoff,C,arbreC;

  _print = 0;
  arbreHW = HullWhite(CouponZero,a,sigma,deltaT);

  G = (100*(1-arbreHW[.,6]) - K);
  G = G.*(G.>0);
  payoff = arbreHW[.,3 4]~G;

  {C,arbreC} = HWvalorisation(arbreHW,deltaT,payoff);
  C = C[rows(CouponZero)];

  retp(C);
endp;
