new;
library spt,finance,tsm,optmum,pgraph;

rndseed 123456;
_opgtol = 0.00005;

F0 = 90.25; 
tau = 0.50; 
sigma = 0.01093;

K = seqa(89.5,0.125,20); 
N = rows(K);

a = 0.01;
deltaT = tau/5;
t = seqa(deltaT,deltaT,5);

TauxZero1 = 0.0975;
TauxZero2 = 0.0975 | 0.0970 | 0.0965 | 0.0960 | 0.0955;

CouponZero1 = exp(-t.*TauxZero1);
CouponZero2 = exp(-t.*TauxZero2);
C1 = zeros(N,1);
C2 = zeros(N,1);

i = 1;
do until i > N;
  C1[i] = optionFuture(CouponZero1,a,sigma,deltaT,K[i]);  
  C2[i] = optionFuture(CouponZero2,a,sigma,deltaT,K[i]);  
  i = i + 1;
endo;


_bahra_zero = 80; _bahra_infini = 100;
_Bahra_int = "intquad1"; _intord = 24;

sv = (ln(F0)-0.5*sigma^2*tau)|(sigma*sqrt(tau));
sv = sv|sv|0.4;
coeff1 = Bahra(C1,K,0.0975,tau*ones(N,1),ones(N,1),sv,0,0);
coeff2 = Bahra(C2,K,0.0975,tau*ones(N,1),ones(N,1),sv,0,0);


Future = seqa(87.5,0.05,111);
pdf1 = pdf_2Ln(Future,coeff1[1],coeff1[2],coeff1[3],coeff1[4],coeff1[5]);
pdf2 = pdf_2Ln(Future,coeff2[1],coeff2[2],coeff2[3],coeff2[4],coeff2[5]);



graphset;
  _pdate = ""; _pnum = 2;
  title("Estimation de la fonction de densite neutre au risque"\
        "\Lmethode de Bahra");
  _pline = 1~5~F0~0~F0~100~1~15~0;
  ytics(0,0.6,0.1,0);
  xlabel("future");
  _parrow = 89.55~0.3~89.85~0.3~2~0.15~01~7~1~6~10;
  xtics(88.5,92,0.5,5);
  graphprt("-c=1 -cf=hw4.eps");
  xy(Future,pdf1~pdf2);


proc optionFuture(CouponZero,a,sigma,deltaT,K);
  local arbreHW,G,payoff,C,arbreC;

  _print = 0;
  arbreHW = HullWhite(CouponZero,a,sigma,deltaT);

  G = (100*(1-arbreHW[.,6]) - K);
  G = G.*(G.>0);
  payoff = arbreHW[.,3 4]~G;

  {C,arbreC} = HWvalorisation(arbreHW,deltaT,payoff);
  C = C[rows(CouponZero)];

  retp(C);
endp;
