@<------------------- holee4.prg ------------------->@

new;
library spt;
SPTset;

tau = 1 | 2 | 3 | 4 ;   /* Maturites 1 an, 2 ans, 3 ans et 4 ans */

{CouponZero,TauxZero} = Vasicek(0.10,0.8,0.11,0.15,0.01,tau);

pi_ = 0.445;
delta = 0.9;
P = arbreHoLee(CouponZero,pi_,delta);
P1 = selectionArbreHoLee(P,1);  
r1 = HoLeeTaux(P1,360,365);   
payoff = 100*HoLeeCap(r1,0.12);  

{C,ArbreC} = HoLeeValorisation(payoff,P1,pi_);  

C4 = selectionArbreHoLee(ArbreC,1);
C3 = selectionArbreHoLee(ArbreC,2);
C2 = selectionArbreHoLee(ArbreC,3);
C1 = selectionArbreHoLee(ArbreC,4);

output file = holee4.out reset;

Msym " ";

print "--- Arbre du caplet 1 an ---";
call affichageArbre(C1); print;
print "--- Arbre du caplet 2 ans ---";
call affichageArbre(C2); print;
print "--- Arbre du caplet 3 ans ---";
call affichageArbre(C3); print;
print "--- Arbre du caplet 4 ans ---";
call affichageArbre(C4); print;

print;
print "Valeur des caplets : ";
print C;
print;
print ftos(sumc(C),"Prime du cap : %lf francs",5,2);

output off;

Msym ".";