@<------------------- bdt1.prg ------------------->@

new;
library spt;
SPTset;

/* Exemple de Black-Derman-Toy [1990] */

let TauxZero = 0.10 0.11 0.12 0.125 0.13;
let Volatilite =  0.19 0.18 0.17 0.16;

/* Resultats obtenus par Black-Derman-Toy [1990] */

let R2 = 0.10 
         0.1432 0.0979 
         0.1942 0.1377 0.0976 
         0.2179 0.1606 0.1183 0.0872
         0.2553 0.1948 0.1486 0.1134 0.0865; 

_print = 0;
R = BDT(TauxZero,Volatilite);

sigma2R = EstimationSigma2(R);
sigma2R2 = EstimationSigma2(R2);

output file = bdt1.out reset;

outwidth 256;
Msym " "; format 11,6;
call affichageArbre(R);
print "--------------------------------------------------------------";
call affichageArbre(R2);
print "--------------------------------------------------------------";
print (seqa(1,1,4).*volatilite^2 ~ sigma2R ~ sigma2R2);

output off;

msym ".";

proc (1) = EstimationSigma2(R);
  local sigma2,n,Rn,lnRn,Ni,i,m,prob,s2;

  sigma2 = {};

  n = 1;
  do until n > rows(TauxZero) - 1;
    Rn = selectionArbre(R,n);
    lnRn = ln(Rn);
    Ni = rows(Rn) - 1;
    i = seqa(Ni,-1,Ni+1);
    prob = (0.5^i).*(0.5^(Ni-i)).*(Ni!)./((Ni-i)!)./(i!);
    m = prob'lnRn;
    s2 = sumc( prob.*((lnRn - m)^2) );
    sigma2 = sigma2 | s2;
    n = n + 1;
  endo;
  
  retp(sigma2);
endp;

