@<------------------- bs.prg ------------------->@

new;
library spt;
SPTset;

S0 = 110;
K = 95;
sigmaS = 0.10;
tau = 60/365;
r0 = 0.05;

proc muCIR(t,r);
  retp( 0.8*(0.10-r) );
endp;

proc sigmaCIR(t,r);
  retp( 0.05*sqrt(r) );
endp;

proc lambdaCIR(t,r);
  retp(0.02*sqrt(r)/0.05);
endp;

{C,Cs} = callBlackScholes(S0,K,sigmaS,0,tau,r0,
                          &muCIR,&sigmaCIR,&lambdaCIR,60,1000|5);

output file = bs.out reset;

print ftos(C,"Prime BS de l'option d'achat : %lf francs",10,5);
print ftos(Cs,"Prime de l'option d'achat (taux d'int. stoch.) : %lf francs",10,5);

output off;