@<------------------- db1.prg ------------------->@

new;
library spt,tsm,optmum,pgraph;
SPTset;
TSMset;

r0 = 0.061448386;  V0 = 0.040419483;  alpha = 0.052139366; 
beta =  0.92955634;  gamma_ = 0.29047384;  delta = 0.17101326; 
eta = 0.012475784;  xi = 0.65761552;  lambda = 1.06184e-005; 

tau = seqa(1/10,1/10,100);
{CouponZeroLS,TauxZeroLS} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau);

obligation = CouponZero_to_Obligation(CouponZeroLS,tau);

tauStar = 2.5~5~7.5;

c1 = DebandtLesne(obligation,2.5,1);
c2 = DebandtLesne(obligation,5,1);
c3 = DebandtLesne(obligation,7.5,1);

c = c1~c2~c3;

CouponZero = DebandtLesne_CouponZero(c,tauStar,tau);
TauxZero = DebandtLesne_TauxZero(c,tauStar,tau);
TauxAterme1 = DebandtLesne_TauxATerme(c1,tauStar[1],tau,0);
TauxAterme2 = DebandtLesne_TauxATerme(c2,tauStar[2],tau,0);
TauxAterme3 = DebandtLesne_TauxATerme(c3,tauStar[3],tau,0);
TauxAterme4 = DebandtLesne_TauxATerme(c,tauStar,5,tau);

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _paxht = 0.30; _pnumht = 0.30; _ptitlht = 0.30;
    _pltype = 6|1|3|4; 
    fonts("simplex simgrma");
    xtics(0,10,1,12); xlabel("\202t\201");

  setwind(1);

    title("Coupon zero P[c]]t[(\202t\201)");
    ytics(0.5,1,0.1,0);
    _plegstr = "LS\000\202t\201[*] = 2.5\000\202t\201[*] = 5\000\202t\201[*] = 7.5";
    _plegctl = {2 5 7 2};
    xy(tau,CouponZeroLS~CouponZero);

  setwind(2);

    title("Taux zero R]t[(\202t\201)");
    ytics(0.052,0.06,0.003,0);
    _plegctl = {2 5 -2 2};
    xy(tau,TauxZeroLS~TauxZero);

  setwind(3);

    title("Taux a terme instantane F]t[(\202t\201,0)");
    ytics(0.05,0.07,0.005,0);
    _plegstr = "\202t\201[*] = 2.5\000\202t\201[*] = 5\000\202t\201[*] = 7.5";
    _plegctl = {2 5 7 2};
    xy(tau,TauxATerme1~TauxATerme2~TauxATerme3);

  setwind(4);

    title("Taux a terme (a 5 ans) F]t[(5,\202t\201)");
    ytics(0.04,0.07,0.01,0);
    _plegctl = {2 5 -2 2};
    xy(tau,TauxATerme4);

    graphprt("-c=1 -cf=_db1.eps");

  endwind;

