@<------------------- ei.prg ------------------->@

new;
library spt,tsm,optmum;
SPTset;
TSMset;

rndseed 123;

{t,x} = simulation_OU(0.1,0.8,0.1,0.06,0,1000,10000,1);
sv = 0.8|0.1|0.06;

indx = seqa(1,10,1000);
x = x[indx];
k = 1;

proc procMu(t,x,theta);
  retp(theta[1]*(theta[2]-x));
endp;

proc gradMu(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( (theta[2]-x) ~ ((theta[1]~0).*ones(Nobs,1)) );
endp;

proc procSigma(t,x,theta);
  retp(theta[3]);
endp;

proc gradSigma(t,x,theta);
  retp((0~0~1));
endp;


proc (1) = procSimul(theta);
  local a,b,sigma,t,x;

  a = theta[1];
  b = theta[2];
  sigma = theta[3];

  {t,x} = simulation_OU(0.1,a,b,sigma,0,1000,10000,3); /* 3 simulations */

  x = x[seqa(1,10,1000),.];

  retp(x);
endp;

_print = 1;
_eds_gradp = &gradMu | &gradSigma;

{theta_ml,theta_ei} = ei_EDS(x,&procMu,&procSigma,0,k,sv,0,0,&procSimul,456,eye(3));

output file = ei.out reset;

_tsm_parnm = "a"|"b"|"sigma";

print; print;
print "              Vraies valeurs    Est. Naive   Inference Indirecte";
print;
call printfmt(_tsm_parnm~sv~theta_ML~theta_EI,0~1~1~1);

output off;

