@<------------------- ls1.prg ------------------->@

new;
library spt,optmum,pgraph;
SPTset;

data = loadd(spt_data_path $+ "frf");
CZ = data[.,2:cols(data)]; 
Dates = data[.,1];
tau = loadd(spt_data_path $+ "mat_frf");
nCZ = rows(tau);

CouponZero = selif(CZ, Dates .== 19940215);
TauxZero = -ln(CouponZero')./tau;

proc (9) = LScoefficients(theta);
  local r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda;

  theta = theta^2;

  r0 = theta[1];
  V0 = theta[2];
  alpha = theta[3];
  beta = theta[4];
  gamma_ = theta[5];
  delta = theta[6];
  eta = theta[7];
  xi = theta[8];
  lambda = theta[9];

  retp(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda);
endp;


proc FonctionCritere(theta);
  local r0,v0,alpha,beta,gamma_,delta,eta,xi,lambda;
  local CZtheorique,TZtheorique,scr;

  {r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda} = LScoefficients(theta);

  {CZtheorique,TZtheorique} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau);

  scr = sumc( (TauxZero-TZtheorique)^2 );
  retp(scr);
endp;


{theta,f,g,retcode} = optmum(&FonctionCritere,rndu(9,1));

{r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda} = LScoefficients(theta);
NomVariable = "r0"|"V0"|"alpha"|"beta"|"gamma"|"delta"|"eta"|"xi"|"lambda";

output file = ls1.out reset;

print "Courbe des taux du 15/02/94";
print "---------------------------";
print "Coefficients du modele de Longstaff et Schwartz";
print;
call printfmt(NomVariable~theta^2,0~1);

output off;


tau_ = seqa(0,1/10,301);
{CZtheorique,TZtheorique} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau_);



graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Estimation de la courbe des taux zero du 15/02/94"\
        "\Lmodele de Longstaff et Schwartz");
  _psym = tau~TauxZero~ones(nCZ,1).*(14~8~2~1~1);
  xlabel("maturite \202t\201 (en annees)");
  ylabel("Taux zero R]t[(\202t\201)");
  xtics(0,30,5,5);   ytics(0.053,0.065,0.002,0);
  graphprt("-c=1 -cf=_ls1.eps");
  xy(tau_,TZtheorique);
